#include <iostream>

using namespace std;

//dekorator nad prostym dziedziczeniem ma t przewag, e mona dodawa funkcjonalnoci dynamicznie w trakcie dziaania programu (decydowa o tym, ktry dekorator uy)

class Widget
{
public:
	virtual void rysuj() = 0;

	virtual ~Widget()
	{
		cout << "Usuwam widget" << endl;
	}
};

class Okno : public Widget
{
private:
	int wysoko;
	int szeroko;
public:
	Okno(int wysoko, int szeroko)
	{
		this->wysoko = wysoko;
		this->szeroko = szeroko;
	}
	void rysuj()
	{
		cout << "Okno o wymiarach: " << szeroko << " x " << wysoko << endl;
	}
	~Okno()
	{
		cout << "Usuwam okno" << endl;
	}
};

class Dekorator : public Widget
{
protected:
	Widget* widget;
public:
	Dekorator(Widget* widget)
	{
		this->widget = widget;
	}
	void rysuj()
	{
		widget->rysuj();
	}

	virtual ~Dekorator()
	{
		cout << "Usuwam dekorator" << endl;
		delete widget;
		cout << "Usunem dekorator" << endl;
	}
};

class Dekorator_ObramowanieOkna : public Dekorator
{
public:
	Dekorator_ObramowanieOkna(Widget* widget)
		: Dekorator(widget)
	{};

	void rysuj()
	{
		Dekorator::rysuj();
		cout << "Obramowanie okna" << endl; //cz dodana - dekoracja
	}

	~Dekorator_ObramowanieOkna()
	{
		cout << "Usuwam dekorator obramowania okna" << endl;
	}
};

class Dekorator_PasekPrzewijaniaPionowego : public Dekorator
{
	public:
	Dekorator_PasekPrzewijaniaPionowego(Widget* widget)
		: Dekorator(widget)
	{};

	void rysuj()
	{
		Dekorator::rysuj();
		cout << "Pasek przewijania pionowego" << endl; //cz dodana - dekoracja
	}

	~Dekorator_PasekPrzewijaniaPionowego()
	{
		cout << "Usuwam dekorator paska przewijanie" << endl;
	}
};

int main_dekorator()
{
	/*
	Widget* widget = new Okno(50,15);
	widget = new Dekorator_ObramowanieOkna(widget);
	widget = new Dekorator_PasekPrzewijaniaPionowego(widget);
	widget = new Dekorator_ObramowanieOkna(widget);
	widget->rysuj();
	delete widget;
	*/

	Widget* widget = new Dekorator_ObramowanieOkna(new Dekorator_PasekPrzewijaniaPionowego(new Dekorator_ObramowanieOkna(new Okno(50,15))));
	widget->rysuj();
	delete widget;

	return 0;
}