#include <iostream>
#include <string>

#include <vector>
#include <iterator>

using namespace std;

//wspdzielenie przez obiekty metod -> kompozyt je integruje

class InterfejsPracownika
{
public:
	void virtual PrzedstawSi() = 0;
};

//Li
class Pracownik : public InterfejsPracownika
{
	string imi;
	string nazwisko;
	int pensja;

public:
	Pracownik(string imi,string nazwisko,int pensja)
	{
		this->imi=imi;
		this->nazwisko=nazwisko;
		this->pensja=pensja;
	}

	void PrzedstawSi()
	{
		cout << imi << " " << nazwisko << ", pensja: " << pensja << "z." << endl;
	}
};

//Kompozyt
class KompozytPracownikw : public InterfejsPracownika
{
	vector<InterfejsPracownika*> pracownicy;

public:
	void DodajPracownika(InterfejsPracownika* nowyPracownik)
	{
		pracownicy.push_back(nowyPracownik);
	}

	void PrzedstawSi()
	{
		cout << "Pracownicy:" << endl;
		for(vector<InterfejsPracownika*>::iterator iterator = pracownicy.begin(); iterator!=pracownicy.end(); iterator++)
		{
			(*iterator)->PrzedstawSi();
		}
	}
};

int main_kompozyt()
{
	Pracownik jan("Jan", "Kowalski", 1999);
	Pracownik franek("Franciszek", "Frankowski", 2500);
	Pracownik krzys("Krzysztof", "Nowak", 5500);

	KompozytPracownikw kompozyt;
	kompozyt.DodajPracownika(&jan);
	kompozyt.DodajPracownika(&franek);
	kompozyt.DodajPracownika(&krzys);

	kompozyt.PrzedstawSi();

	return 0;
}