#include <iostream>
#include <string>

using namespace std;

//pozwala odseparowa implementacj obiektu od jego abstrakcji

//abstrakcja telewizora
class InterfejsTelewizora
{
public:
	virtual void Wcz() = 0;
	virtual void Wycz() = 0;
	virtual void PrzeczNaKana(int numerKanau) = 0;
};

class TelewizorSamsung : public InterfejsTelewizora
{
public:
	void Wcz()
	{
		cout << "Telewizor Samsung zosta wczony" << endl;
	}

	void Wycz()
	{
		cout << "Telewizor Samsung zosta wyczony" << endl;
	}

	void PrzeczNaKana(int numerKanau)
	{
		cout << "Kana w telewizorze Samsung zmieniony na: " << numerKanau << endl;
	}
};

class TelewizorLG : public InterfejsTelewizora
{
public:
	void Wcz()
	{
		cout << "Telewizor LG zosta wczony" << endl;
	}

	void Wycz()
	{
		cout << "Telewizor LG zosta wyczony" << endl;
	}

	void PrzeczNaKana(int numerKanau)
	{
		cout << "Kana w telewizorze LG zmieniony na: " << numerKanau << endl;
	}
};

//abstrakcja pilota
class InterfejsPilota
{
protected:
	InterfejsTelewizora* telewizor;

public:
	virtual void przyciskWcz() = 0;
	virtual void przyciskWycz() = 0;	
};

//konkretny pilot
class Pilot1 : public InterfejsPilota
{
public:
	Pilot1(InterfejsTelewizora* telewizor)
	{
		this->telewizor = telewizor;
	}

	virtual void przyciskWcz()
	{
		telewizor->Wcz();
	}

	virtual void przyciskWycz()
	{
		telewizor->Wycz();
	}
};

int main_most()
{	
	InterfejsTelewizora* telewizorSamsung = new TelewizorSamsung();
	InterfejsTelewizora* telewizorLG = new TelewizorLG();

	InterfejsPilota* pilotDoTelewizoraSamsung = new Pilot1(telewizorSamsung);
	InterfejsPilota* pilotDoTelewizoraLG = new Pilot1(telewizorLG);

	pilotDoTelewizoraSamsung->przyciskWcz();
	pilotDoTelewizoraLG->przyciskWcz();

	pilotDoTelewizoraLG->przyciskWycz();

	return 0;
}