#include <iostream>
#include <string>

using namespace std;

//penomocnik (ang. proxy), otacza klas dodajc np. walidacje

class InterfejsSamochodu
{
public:
	virtual void Prowad() = 0;
};

class Osoba
{
	string imi;
	bool czyPosiadaPrawoJazdy;

public:
	Osoba(string imi, bool czyPosiadaPrawoJazdy)
	{
		this->imi = imi;
		this->czyPosiadaPrawoJazdy = czyPosiadaPrawoJazdy;
	}

	bool CzyPosiadaPrawoJazdy()
	{
		return czyPosiadaPrawoJazdy;
	}
};

class Samochd : public InterfejsSamochodu
{
public:
	void Prowad()
	{
		cout << "Brum, brum!" << endl;
	}
};

class PenomocnikSamochodu : public InterfejsSamochodu
{
	InterfejsSamochodu* samochd;
	Osoba* osoba;

public:
	PenomocnikSamochodu(Osoba* osoba)
	{
		this->osoba = osoba;
		samochd = new Samochd();
	}

	void Prowad()
	{
		if(!osoba->CzyPosiadaPrawoJazdy())
		{
			cout << "Wskazana osoba nie moe by kierowc samochodu" << endl;
		}
		else
		{
			samochd->Prowad();
		}
	}
};

int main_pelnomocnik()
{
	Osoba jan("Jan", true);
	PenomocnikSamochodu penomocnikSamochodu(&jan);
	penomocnikSamochodu.Prowad();

	Osoba krzy("Krzy", false);
	PenomocnikSamochodu penomocnikSamochodu2(&krzy);
	penomocnikSamochodu2.Prowad();

	return 0;
}